最短路计数

最短路计数

提交数: 51, 通过率: 54.9%, 平均分: 65.49

题目描述:

给出一个N个顶点M条边的无向无权图,顶点编号为1~N。问从顶点1开始,到其他每个点的最短路有几条?

输入格式:

第一行包含2个正整数N, M, 分别为图的顶点数与边数。

接下来M行,每行两个正整数x, y,表示有一条从顶点x连向点y的边。请注意可能有自环与重边。

输出格式:

共N行,每行一个非负整数,第i行输出从顶点1到顶点i有多少条不同的最短路,由于结果的值有可能会很大,你只需要输出结果 mod 100003即可。如果无法到达顶点i,则输出0。

数据范围:

对于20%的数据,N<=100。

对于60%的数据,N<=1000。

对于100%的数据,N<=100,000, M<=200,000。

样例输入:
复制代码
5 7
1 2
1 3
2 4
3 4
2 3
4 5
4 5
样例输出:
复制代码
1
1
1
2
4
提示:

样例解释:

1到5的最短路有4条,分别为2条1-2-4-5和2条1-3-4-5 ( 由于4-5的边有2条)。

此题使用SPFA(Shortest Path Faster Algorithm)

#include <bits/stdc++.h>

using namespace std;

int n,m,f1000005,t4000005,n14000005,g,dis1000005,ans1000005;

bool book1000005;

queue<int> que;

void SPFA(int u,int v) {

tg=v,n1g=fu,fu=g++;

}

int dfs(int u) {

if(ansu)return ansu;//如果ansu!=0直接输出,否则更新并输出

for(int i=fu; i!=-1; i=n1i)

if(disu-1==dist\[i])ansu=(ansu+dfs(ti))%100003;//统计最短路的条数并更新

return ansu;

}

int main() {

scanf("%d%d",&n,&m);

for(int i=1; i<=n; i++)fi=-1,disi=INT_MAX;//将数组初始化

for(int i=1,u,v; i<=m; i++)scanf("%d%d",&u,&v),SPFA(u,v),SPFA(v,u);//输入之后构建邻接矩阵

dis1=0,que.push(1),book1=1;

while(!que.empty()) {//循环寻找最短路

int f1=que.front();//更新出发点

que.pop(),bookf1=0;//删除已遍历的元素

for(int i=ff1; i!=-1; i=n1i)//遍历出发的边

if(disf1+1<dist\[i]) {//如果比之前的最短路短

dist\[i]=disf1+1;//更新最短路

if(!bookt\[i])que.push(ti),bookt\[i]=1;//标记已遍历过的节点和边

}

}

ans1=1;

for(int i=1; i<=n; i++)printf("%d\n",dfs(i));//输出最短路的个数

return 0;

}

相关推荐
其实防守也摸鱼13 小时前
个人学习 Pwn 思路:从基础到漏洞利用的进阶路径
大数据·前端·人工智能·chrome·算法·安全·网络安全
Nuanyt13 小时前
LeetCode Hot 100 链表专题(五)· 2 题(Java)
java·算法·leetcode·链表
w_zero_one16 小时前
递归算法(一)
java·开发语言·算法
风影同志7832418 小时前
20 个比特能装下多少行情?——实测拆解 Kronos 的 K 线分词器
算法
写的都是BUG18 小时前
APK 里的钥匙,一直就放在门口:聊聊加固真正该做什么
前端·算法
地平线开发者19 小时前
CLIP 的零样本分类:一组文本如何变成图像分类器?
算法
京东云开发者20 小时前
从“会生成”到“能生产”:萤火虫 AIGC 平台的 AI Infra 实践
算法·aigc·产品
youshi666820 小时前
PID——算法改进
算法
一只不想敲代码的程序猿21 小时前
如何更高效地拆解问题?
算法